/*
 * A1.java
 *
 * Created on 9 July 2002, 09:09
 */

import java.awt.*;
import java.awt.event.KeyEvent;

/**
 *
 * @author  Robert Sheehan
 */
public class A1 extends javax.swing.JFrame {
    
    /** The dispatcher. */
    private Dispatcher dispatcher;

    /** Whether the system is paused or not. */
    private boolean currentlyPaused = false;
    
    /** Creates new form A1 */
    public A1() {
/*
      // for the JDK 1.3.1 package
      DefaultFocusManager focusManager = new DefaultFocusManager()
      {
        public void processKeyEvent(Component fComp, KeyEvent e)
        {
          if (e.getID() == KeyEvent.KEY_TYPED)
          IOSystem.putChar(e.getKeyChar());
          e.consume();
        }
      };
      FocusManager.setCurrentManager( focusManager );

*/
        // only works with JDK 1.4 onwards
        initComponents();
        KeyboardFocusManager focusManager = KeyboardFocusManager.getCurrentKeyboardFocusManager();
        focusManager.addKeyEventDispatcher(new KeyEventDispatcher() {
            public boolean dispatchKeyEvent(KeyEvent e) {
                if (e.getID() == KeyEvent.KEY_TYPED)
                    IOSystem.putChar(e.getKeyChar());
                e.consume();
       
                return true; // don't do anything more with this key event
            }
        });
        
        dispatcher = new Dispatcher(this);
        IOSystem.setDispatcher(dispatcher);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jSplitPane1 = new javax.swing.JSplitPane();
        waitingScrollPane = new javax.swing.JScrollPane();
        waitingPanel = new javax.swing.JPanel();
        stackScrollPane = new javax.swing.JScrollPane();
        stackPanel = new javax.swing.JPanel();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        newInteractiveMenuItem = new javax.swing.JMenuItem();
        newBackgroundMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        editMenu = new javax.swing.JMenu();
        killRunningMenuItem = new javax.swing.JMenuItem();
        pauseMenuItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        aboutMenuItem = new javax.swing.JMenuItem();

        setTitle("CompSci 340 SoftEng 370 A1");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jSplitPane1.setDividerLocation(300);
        waitingPanel.setLayout(new javax.swing.BoxLayout(waitingPanel, javax.swing.BoxLayout.Y_AXIS));

        waitingScrollPane.setViewportView(waitingPanel);

        jSplitPane1.setLeftComponent(waitingScrollPane);

        stackPanel.setLayout(new javax.swing.BoxLayout(stackPanel, javax.swing.BoxLayout.Y_AXIS));

        stackScrollPane.setViewportView(stackPanel);

        jSplitPane1.setRightComponent(stackScrollPane);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        fileMenu.setText("File");
        newInteractiveMenuItem.setText("New interactive");
        newInteractiveMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newInteractiveMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(newInteractiveMenuItem);
        newBackgroundMenuItem.setText("New background");
        newBackgroundMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newBackgroundMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(newBackgroundMenuItem);
        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitMenuItem);
        menuBar.add(fileMenu);
        editMenu.setText("Edit");
        killRunningMenuItem.setText("Kill running process");
        killRunningMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                killRunningMenuItemActionPerformed(evt);
            }
        });

        editMenu.add(killRunningMenuItem);
        pauseMenuItem.setText("Pause");
        pauseMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pauseMenuItemActionPerformed(evt);
            }
        });

        editMenu.add(pauseMenuItem);
        menuBar.add(editMenu);
        helpMenu.setText("Help");
        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });

        helpMenu.add(aboutMenuItem);
        menuBar.add(helpMenu);
        setJMenuBar(menuBar);

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setSize(new java.awt.Dimension(600, 600));
        setLocation((screenSize.width-600)/2,(screenSize.height-600)/2);
    }//GEN-END:initComponents

    private void pauseMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pauseMenuItemActionPerformed
        // Add your handling code here:
        if (currentlyPaused) {
            pauseMenuItem.setText("Pause");
        }
        else {
            pauseMenuItem.setText("Continue");
        }
        currentlyPaused = !currentlyPaused;
        dispatcher.pauseSystem(currentlyPaused);
    }//GEN-LAST:event_pauseMenuItemActionPerformed

    private void killRunningMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_killRunningMenuItemActionPerformed
        // Add your handling code here:
        dispatcher.killRunningProcess();
    }//GEN-LAST:event_killRunningMenuItemActionPerformed

    private void newBackgroundMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newBackgroundMenuItemActionPerformed
        // Add your handling code here:
        ProcessArea processArea = new ProcessArea(this, false);
        A1Process process = processArea.getProcess();
        dispatcher.submitProcess(process);
	// process has to be displayed
	addToStack(process);
	// process has to be set to run mode
	dispatcher.makeProcessRun(process);
	

    }//GEN-LAST:event_newBackgroundMenuItemActionPerformed

    private void newInteractiveMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newInteractiveMenuItemActionPerformed
        // Add your handling code here:
        ProcessArea processArea = new ProcessArea(this, true);
        A1Process process = processArea.getProcess();
        dispatcher.submitProcess(process);

    }//GEN-LAST:event_newInteractiveMenuItemActionPerformed

    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
        // Add your handling code here:
        (new AboutDialog(this, true)).show();
    }//GEN-LAST:event_aboutMenuItemActionPerformed

    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitMenuItemActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
     * Adds a process area to the top of the displayed stack.
     * @param process the process to add
     */
    public synchronized void addToStack(A1Process process) {
        stackPanel.add(process.getOutputArea(), 0); // the top of the stack
        stackPanel.revalidate();
    }

    /**
     * Removes a process area from the displayed process stack when it is finished or waiting.
     * @param process the process to remove
     */
    public synchronized void removeFromStack(A1Process process) {
        stackPanel.remove(process.getOutputArea());
        stackPanel.repaint();
    }

    /**
     * Puts a process in the waiting panel.
     * @param process the process
     */
    public synchronized void addToWaiting(A1Process process) {
        waitingPanel.add(process.getOutputArea());
        waitingPanel.revalidate();
    }

    /**
     * Removes a process from the waiting panel.
     * @param process the process
     */
    public synchronized void removeFromWaiting(A1Process process) {
        waitingPanel.remove(process.getOutputArea());
        waitingPanel.repaint();
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new A1().show();
    }
    
    /**
     * Gets informed when a process area has been clicked in.
     * @param focusProcess the process corresponding to the process area
     */
    public void catchFocusChange(A1Process focusProcess) {
        switch (focusProcess.getState()) {
            case A1Process.READY :
                dispatcher.makeProcessRun(focusProcess);
                removeFromStack(focusProcess);
                addToStack(focusProcess);
                break;
            case A1Process.WAITING :
                IOSystem.setSelectedProcess(focusProcess);
                break;
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JScrollPane stackScrollPane;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JPanel waitingPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem killRunningMenuItem;
    private javax.swing.JMenuItem pauseMenuItem;
    private javax.swing.JMenuItem newBackgroundMenuItem;
    private javax.swing.JPanel stackPanel;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JMenuItem newInteractiveMenuItem;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu editMenu;
    private javax.swing.JScrollPane waitingScrollPane;
    private javax.swing.JMenu helpMenu;
    // End of variables declaration//GEN-END:variables
    
}
