/*
 * Background.java
 *
 * Created on 9 July 2002, 10:39
 */

import javax.swing.*;

/**
 * A background process runs until completed.
 * It requires no keyboard input.
 *
 * @author  Robert Sheehan
 */
public class Background extends A1Process {
    
    /** Creates a new instance of Background.
     * @param area the corresponding ProcessArea
     */
    public Background(ProcessArea area) {
        super(area);
        loopCount = (int)(10 + 20 * Math.random());
        IOSystem.print(this, " - doing "+loopCount+" loops.\n");
    }
    
    /**
     * The real work of the process.
     */
    protected void execute() {
        int loop = 0;
        while (live && loop < loopCount) {
            checkForInterrupts();
            if (!live)
                return; // has been killed
            doSomeWork();
            loop++;
        }
    }
    
}
