/*
 * Interactive.java
 *
 * Created on 9 July 2002, 10:38
 */

import javax.swing.*;

/**
 * An interactive process is one that waits for keyboard input as well as
 * doing computation.
 *
 * @author  Robert Sheehan
 */
public class Interactive extends A1Process {
    
    /** Creates a new instance of Interactive.
     * @param area the corresponding ProcessArea
     */
    public Interactive(ProcessArea area) {
        super(area);
    }
    
    /**
     * The real work of the process.
     */
    protected void execute() {
        while (live) {
            checkForInterrupts();
            if (!live)
                return; // has been killed
            input:
                while (live) { // usually keeps trying until a legal value is entered
                    try {
                        IOSystem.print(this, "\nEnter the number of \"*\"s you want (-1 to finish): ");
                        loopCount = Integer.parseInt(IOSystem.readLine(this));
                        if (loopCount == -1) // the process has finished
                            return;
                        if (loopCount > -1) // got a legal value
                            break input;
                    }
                    catch (NumberFormatException ex) {}
                }
                // this next bit is exactly the same as the Background execute method
                int loop = 0;
                while (live && loop < loopCount) {
                    checkForInterrupts();
                    if (!live)
                        return; // has been killed
                    doSomeWork();
                    loop++;
                }
        }
    }
    
}